package mastermind.solver;

import mastermind.model.Guess;
import mastermind.model.Result;

/**
 * Mastermind Solver: Interface.
 */
/* -----------------------------------------------------------------------------
 * Version History:
 * 2012-05-03.v01   FeRo    init version
 * -----------------------------------------------------------------------------
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 * @version 2012-05-03.v2
 */
public interface ISolver
{

    /**
     * Liefert den nächsten Rateversuch (Guess)
     * @param lastResult Resultat des vorherigen Guess
     * @param guessID der wie vielte Rateversuch
     * @return nächsten zu vergleichenen Guess
     */
    Guess getNextGuess(Result lastResult, int guessID);
}
