package mastermind.model;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class SettingsTest
{

    public SettingsTest()
    {
    }

    /**
     * Test of setSettings method, of class Settings.
     * @throws Exception
     */
    @Test
    public void testSetSettingsAndGetter() throws Exception
    {
        System.out.println("setSettings");
        int numberOfColors = 4;
        boolean allowDuplicateColor = true;
        int numberOfPegs = 6;
        int numberOfRows = 8;
        Settings instance = new Settings();
        instance.setSettings(numberOfColors, allowDuplicateColor, numberOfPegs, numberOfRows);
        // testGetNumberOfColors()
        System.out.println("getNumberOfColors");
        assertEquals(numberOfColors, instance.getNumberOfColors());
        // testGetAllowDuplicateColor
        System.out.println("getAllowDuplicateColor");
        assertEquals(allowDuplicateColor, instance.getAllowDuplicateColor());
        // testGetNumberOfPegs
        System.out.println("getNumberOfPegs");
        assertEquals(numberOfPegs, instance.getNumberOfPegs());
        // testGetNumberOfRows
        System.out.println("getNumberOfRows");
        assertEquals(numberOfRows, instance.getNumberOfRows());
    }

    /**
     * Test of setNumberOfColors method, of class Settings.
     * @throws Exception
     */
    @Test
    public void testSetNumberOfColors() throws Exception
    {
        System.out.println("setNumberOfColors");
        int numberOfColors = 4;
        Settings instance = new Settings();
        instance.setNumberOfColors(numberOfColors);
        assertEquals(numberOfColors, instance.getNumberOfColors());
    }

    /**
     * Test of setNumberOfColors method, of class Settings. => Exception MIN-Value
     * @throws Exception
     */
    @Test(expected = IllegalArgumentException.class)
    public void testSetNumberOfColorsExceptionMin() throws Exception
    {
        System.out.println("setNumberOfColors Exception: Min");
        int numberOfColors = (Settings.ANZ_COLOR_MIN - 1);
        Settings instance = new Settings();
        instance.setNumberOfColors(numberOfColors);
    }

    /**
     * Test of setNumberOfColors method, of class Settings. => Exception MAX-Value
     * @throws Exception
     */
    @Test(expected = IllegalArgumentException.class)
    public void testSetNumberOfColorsExceptionMax() throws Exception
    {
        System.out.println("setNumberOfColors Exception: Max");
        int numberOfColors = (Settings.ANZ_COLOR_MAX + 1);
        Settings instance = new Settings();
        instance.setNumberOfColors(numberOfColors);
    }

    /**
     * Test of setNumberOfPegs method, of class Settings.
     * @throws Exception
     */
    @Test
    public void testSetNumberOfPegs() throws Exception
    {
        System.out.println("setNumberOfPegs");
        int numberOfPegs = 6;
        Settings instance = new Settings();
        instance.setNumberOfPegs(numberOfPegs);
        assertEquals(numberOfPegs, instance.getNumberOfPegs());
    }

    /**
     * Test of setNumberOfPegs method, of class Settings. -> MIN Exception
     * @throws Exception
     */
    @Test(expected = IllegalArgumentException.class)
    public void testSetNumberOfPegsExceptionMin() throws Exception
    {
        System.out.println("setNumberOfPegs Exception: Min");
        int numberOfPegs = Settings.ANZ_PEG_MIN - 1;
        Settings instance = new Settings();
        instance.setNumberOfPegs(numberOfPegs);
    }

    /**
     * Test of setNumberOfPegs method, of class Settings. -> Max Exception
     * @throws Exception
     */
    @Test(expected = IllegalArgumentException.class)
    public void testSetNumberOfPegsExceptionMax() throws Exception
    {
        System.out.println("MaxPeg: " + Settings.ANZ_PEG_MAX);
        System.out.println("setNumberOfPegs Exception: Max");
        int numberOfPegs = Settings.ANZ_PEG_MAX + 1;
        Settings instance = new Settings();
        instance.setNumberOfPegs(numberOfPegs);
    }

    /**
     * Test of setNumberOfRows method, of class Settings.
     * @throws Exception
     */
    @Test
    public void testSetNumberOfRows() throws Exception
    {
        System.out.println("setNumberOfRows");
        int numberOfRows = 6;
        Settings instance = new Settings();
        instance.setNumberOfRows(numberOfRows);
        assertEquals(numberOfRows, instance.getNumberOfRows());
    }

    /**
     * Test of setNumberOfRows method, of class Settings. -> Exception MIN
     * @throws Exception
     */
    @Test(expected = IllegalArgumentException.class)
    public void testSetNumberOfRowsExceptionMin() throws Exception
    {
        System.out.println("setNumberOfRows Exception: Min");
        int numberOfRows = Settings.ANZ_GUESS_MIN - 1;
        Settings instance = new Settings();
        instance.setNumberOfRows(numberOfRows);
    }

    /**
     * Test of setNumberOfRows method, of class Settings. -> Exception Max
     * @throws Exception
     */
    @Test(expected = IllegalArgumentException.class)
    public void testSetNumberOfRowsExceptionMax() throws Exception
    {
        System.out.println("setNumberOfRows Exception: Max");
        int numberOfRows = Settings.ANZ_GUESS_MAX + 1;
        Settings instance = new Settings();
        instance.setNumberOfRows(numberOfRows);
    }

    /**
     * Test of setAllowDuplicateColor method, of class Settings.
     */
    @Test
    public void testSetAllowDuplicateColor_true()
    {
        System.out.println("setAllowDuplicateColor: true");
        boolean allowDuplicateColor = true;
        Settings instance = new Settings();
        instance.setAllowDuplicateColor(allowDuplicateColor);
        assertEquals(allowDuplicateColor, instance.getAllowDuplicateColor());

        System.out.println("setAllowDuplicateColor: false");
        allowDuplicateColor = false;
        instance.setAllowDuplicateColor(allowDuplicateColor);
        assertEquals(allowDuplicateColor, instance.getAllowDuplicateColor());
    }
    /**
     * Test of setAllowDuplicateColor method, of class Settings.
     */
    @Test
    public void testSetAllowDuplicateColor_false()
    {
        System.out.println("setAllowDuplicateColor: false");
        boolean allowDuplicateColor = false;
        Settings instance = new Settings();
        instance.setAllowDuplicateColor(allowDuplicateColor);
        assertEquals(allowDuplicateColor, instance.getAllowDuplicateColor());
    }
}
